local _G = _G;
local GetTime = GetTime
local string, ipairs = string, ipairs
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch = print, string.format, string.gmatch
local red = RED_FONT_COLOR
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local testbar
local newtabs = true
local unitdb = {}
unitdb.frostwolf = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- Frostwolf
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	,69791 -- Feuergeist
	,59390 -- Spottendes Banner
	,48638 -- Schlachtstandarte der Gilde
	,84774 -- Tödliche Eisenfalle
	,83925 -- Eisenfalle
	}

-- 90432 FAIL	
	
function cmdut(arg)
	
	if arg == "test" then
		local m = 0
		for i, unitid in ipairs(unitdb.ignornpc) do
			m = m + 1
		end
		print(m.." "..table_getn(unitdb.ignornpc))
	elseif  arg == "test2" then
		
	elseif  arg == "reset" then
		UnrealTargets:reset_frames()
	end	
end

do
	SlashCmdList["cmdut"] = cmdut; 
	SLASH_cmdut1 = "/utar";
	SLASH_cmdut2 = "/UnrealTargets";
	SLASH_cmdut3 = "/unrealtargets";
	SLASH_cmdut4 = "/unrealtarget";
end

function UnrealTargets:set_hp_frame(posix, posiy)
	local NewStatusBar = CreateFrame("StatusBar", nil, UIParent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(150)
	NewStatusBar:SetHeight(15)
	NewStatusBar:SetPoint("RIGHT",posix, posiy)
	local c = red;
	NewStatusBar:SetStatusBarColor(c.r, c.g, c.b)
	return NewStatusBar
end

function UnrealTargets:Initialize()

end



function UnrealTargets:frequently_frame_update(...)
	guid = UnitGUID(...)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	local max_health = UnitHealthMax(...)
	local currenthealth = UnitHealth(...)
	if max_health ~= 0 and currenthealth ~= 0 then
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
	for k, unitguid in ipairs(unitdb.frostwolf) do
		if unitguid == destGUID then
			unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
			local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
			health = string_format("%.0f", health)
			unitdb.units[destGUID].bar:SetValue(health)
			health = health.."%"
			unitdb.units[destGUID].fonthppercent:SetText(health)
		end
	end
end

function UnrealTargets:frame_update(time, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",destGUID)
	local sourcetype = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false
	local ignornpcid = false
	for i, unitguid in ipairs(unitdb.frostwolf) do
		if unitguid == destGUID then
			if unit ~= "player" then
				if event == "UNIT_DIED" then
					table_remove(unitdb.frostwolf, i)
					unitdb.units[unitguid].bar:Hide()
					for j, upunitguid in ipairs(unitdb.frostwolf) do
						unitdb.units[upunitguid].bar:SetPoint("RIGHT",-250,  0-(j-1)*20)
					end
				elseif event == "SWING_DAMAGE" then
					_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				end
			end
			isindb = true
		end
	end
	if not isindb then
		if type == "Creature" and sourcetype == "Player" then
			ignornpcid = self:ignor_npc(npc_id)
			if ignornpcid == false then
				SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
				table_insert(unitdb.frostwolf, destGUID)
				unitdb.units[destGUID] = {}
				if unitdb.unitsmaxhp[npc_id] then
					unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
				else
					unitdb.units[destGUID].maxhp = 1000000
				end
				unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp
				unitdb.units[destGUID].npcid = npc_id
				unitdb.units[destGUID].bar = UnrealTargets:set_hp_frame(-250, 0-table_getn(unitdb.frostwolf)*20)
				unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
				unitdb.units[destGUID].fontname:SetPoint("LEFT", 0, 0)
				unitdb.units[destGUID].fontname:SetText(destName)
				unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
				unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
				unitdb.units[destGUID].fonthppercent:SetPoint("RIGHT", 0, 0)
				unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
			end
		end
	end
end

function UnrealTargets:ignor_npc(npc_id)
	for i, unitid in ipairs(unitdb.ignornpc) do
		if tonumber(npc_id) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:hp_update(destGUID, dmg)
	unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
	local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
	health = string_format("%.0f", health)
	unitdb.units[destGUID].bar:SetValue(health)
	health = health.."%"
	unitdb.units[destGUID].fonthppercent:SetText(health)
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
				if npc_id == unitdb.units[unitguid].npcid then
					local deltahp = unitdb.units[unitguid].maxhp - unitdb.units[unitguid].hp 
					unitdb.units[unitguid].maxhp = max_health
					unitdb.units[unitguid].hp = unitdb.units[unitguid].maxhp -deltahp
					self:hp_update(unitguid, 0)
				end		
			end
		end
	end
end

function UnrealTargets:reset_frames()
	for k, unitguid in ipairs(unitdb.frostwolf) do
		unitdb.units[unitguid].bar:Hide()
		unitdb.units[unitguid] = {}
		table_remove(unitdb.frostwolf, 0)
	end
	unitdb.frostwolf = {}
	unitdb.units = {}
end

UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		--self:Initialize(...)
		--UnrealTargets:target_updates()
		--print("login")
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:frame_update(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'ENCOUNTER_END' then
		self:reset_frames()
	elseif event == 'PLAYER_REGEN_ENABLED' then
		self:reset_frames()
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		self:frequently_frame_update(...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end



UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:RegisterEvent('ENCOUNTER_END')
UnrealTargets:RegisterEvent('PLAYER_REGEN_ENABLED')
UnrealTargets:SetScript('OnEvent', OnEvent)



